#!/usr/bin/env python

import os
import sys
import re

# This is here for windows users since their os.getcwd
# returns a path in the style of C:\my\folder\file
# Qt (and PyQt for that matter) use unix style paths
# even when they are implemented on windows, so it must be converted
def correctWindowsPath (path):
	correct_path = None
	if re.compile ("[A-Za-z]:\.*").match (path):
		correct_path = path[2:].replace ("\\", "/")
	else:
		correct_path = path

	return correct_path

pwd = correctWindowsPath (str (os.getcwd ()))

pythonVersion = sys.version_info

file = open (pwd + "/client/Constants.py", "w")

file.write ("# James Dura jd992@drexel.edu\n\n")
file.write ("# Basin Client Constants\n")
file.write ("# autogenerated by basin_client/build_client.sh\n\n")
file.write ("BASE_DIR = \"" + pwd + "\"\n\n")
file.write ("SRC_DIR = BASE_DIR + \"/client\"\n\n")
file.write ("ICON_DIR = BASE_DIR + \"/icons\"\n\n")
file.write ("# Icons\n")
file.write ("ICON_DEFAULT = ICON_DIR + \"/default.png\"\n")
file.write ("ICON_BASIN = ICON_DIR + \"/basin.png\"\n")
file.write ("# Some predefined regular expressions, as per QRegExp\n")
file.write ("# http://www.riverbankcomputing.com/Docs/PyQt4/html/qregexp.html\n")
file.write ("REGEXP_VAR = \"[A-Za-z_][0-9A-Za-z_]*\"\n")
file.write ("DOUBLE_PRECISION = 2\n\n")
file.write ("STATUS_WAIT = 2.5\n\n")
file.write ("from PyQt4.QtGui import QPushButton\n")
file.write ("class BQPushButton (QPushButton):\n")
file.write ("\tdef __init__ (self, label, parent, enabled = True):\n")
file.write ("\t\tQPushButton.__init__ (self, label)\n")
file.write ("\t\tparent.addWidget (self)\n")
file.write ("\t\tself.setEnabled (enabled)\n\n")
file.write ("from PyQt4.QtCore import Qt\n\n")
file.write ("from PyQt4.QtGui import QHBoxLayout\n")
file.write ("class BQHBoxLayout (QHBoxLayout):\n")
file.write ("\tdef __init__ (self, parent, set = False, alignment = Qt.AlignLeft):\n")
file.write ("\t\tQHBoxLayout.__init__ (self)\n")
file.write ("\t\tif set:\n")
file.write ("\t\t\tparent.setLayout (self)\n")
file.write ("\t\telse:\n")
file.write ("\t\t\tparent.addLayout (self, alignment)\n\n")
file.write ("from PyQt4.QtGui import QVBoxLayout\n")
file.write ("class BQVBoxLayout (QVBoxLayout):\n")
file.write ("\tdef __init__ (self, parent, set = False, alignment = Qt.AlignLeft):\n")
file.write ("\t\tQVBoxLayout.__init__ (self)\n")
file.write ("\t\tif set:\n")
file.write ("\t\t\tparent.setLayout (self)\n")
file.write ("\t\telse:\n")
file.write ("\t\t\tparent.addLayout (self, alignment)\n\n")
file.write ("from PyQt4.QtGui import QLabel\n")
file.write ("from PyQt4.QtGui import QLineEdit\n")
file.write ("class BTextField (QLineEdit):\n")
file.write ("\tdef __init__ (self, parent, labelText, fieldText):\n")
file.write ("\t\tlayout = BQHBoxLayout (parent)\n")
file.write ("\t\tlabel = QLabel (labelText + \":\")\n")
file.write ("\t\tlabel.setAlignment (Qt.AlignVCenter | Qt.AlignRight)\n")
file.write ("\t\tlayout.addWidget (label)\n")
file.write ("\t\tQLineEdit.__init__ (self, fieldText)\n")
file.write ("\t\tlayout.addWidget (self)\n")
file.close ()

os.system ("cp client/Constants.py client/Dock/Constants.py")
os.system ("cp client/Constants.py client/Viewers/Constants.py")
