"""
"""

import PyQt4.QtGui
import PyQt4.QtCore

import Constants


class DeleteDialog (PyQt4.QtGui.QDialog):
	def __init__ (self, win, name):
		# sets up the QDialog with the correct icon, title, and then gives it a vertical main layout
		PyQt4.QtGui.QDialog.__init__ (self, win)
		self.setWindowTitle ("Delete")
		self.setWindowIcon (PyQt4.QtGui.QIcon (Constants.ICON_DIR + "/misc/delete.png"))
		layout = PyQt4.QtGui.QVBoxLayout ()
		self.setLayout (layout)

		# The main layout is a vertical layout which comprises of these two horizontal layouts
		topLayout = PyQt4.QtGui.QHBoxLayout ()
		bottomLayout = PyQt4.QtGui.QHBoxLayout ()
		layout.addLayout (topLayout)
		layout.addLayout (bottomLayout)

		# The QLabel directing the user to choose a button
		topLayout.addWidget (PyQt4.QtGui.QLabel ("Are you sure you want to delete " + name + "?"))

		# Adds the buttons, and connects them to QDialog's accept and reject, and to the bottom layout
		acceptButton = Constants.BQPushButton ("&Yes", bottomLayout)
		PyQt4.QtCore.QObject.connect (acceptButton, PyQt4.QtCore.SIGNAL ("clicked ()"), self.accept)
		rejectButton = Constants.BQPushButton ("&No", bottomLayout)
		PyQt4.QtCore.QObject.connect (rejectButton, PyQt4.QtCore.SIGNAL ("clicked ()"), self.reject)

		# Execute the dialog, it will remain until resolved
		self.exec_ ()


class NameDialog (PyQt4.QtGui.QDialog):
	def __init__ (self, win, type, icon):
		# Sets up normal PyQt4.QtGui.QDialog stuff, with the correct title and icon,
		# as well as give it a main vertical layout
		PyQt4.QtGui.QDialog.__init__ (self, win)
		self.setWindowTitle (type)
		self.setWindowIcon (icon)
		layout = PyQt4.QtGui.QVBoxLayout ()
		self.setLayout (layout)

		# Set up horizontal layouts in the main vertical layout
		topLayout = PyQt4.QtGui.QHBoxLayout ()
		bottomLayout = PyQt4.QtGui.QHBoxLayout ()
		layout.addLayout (topLayout)
		layout.addLayout (bottomLayout)

		# Create a line edit, but with a regular expression validator
		# Which is essentially a line that thwe user edits, but if their keystrokes
		# don't agree with the regular expression given, their input won't even show up
		# This is nice, because only valid variable names should go here.
		self.name = PyQt4.QtGui.QLineEdit ()
		# REGEXP_VAR defined in BASIN_constants.py
		regexp = PyQt4.QtCore.QRegExp (Constants.REGEXP_VAR)
		valid = PyQt4.QtGui.QRegExpValidator (regexp, self.name)
		self.name.setValidator (valid)
		topLayout.addWidget (PyQt4.QtGui.QLabel (PyQt4.QtCore.QString ("Name:")))
		topLayout.addWidget (self.name)

		# Adds the buttons, and connects them to PyQt4.QtGui.QDialog's accept
		# and reject, and to the bottom layout
		acceptButton = Constants.BQPushButton ("Ok", bottomLayout)
		PyQt4.QtCore.QObject.connect (acceptButton, PyQt4.QtCore.SIGNAL ("clicked ()"), self.accept)
		rejectButton = Constants.BQPushButton ("Cancel", bottomLayout)
		PyQt4.QtCore.QObject.connect (rejectButton, PyQt4.QtCore.SIGNAL ("clicked ()"), self.reject)

		# Execute the dialog, it will remain until resolved
		self.exec_ ()

